;Testprogramm: Blinken P1.0 und Reaktion auf seriellen Empfang
;Quarzfrequenz:  24 MHz

$include (reg52.inc)	;Prozessordefinition: 8252
        
        org     0000H           ;Speicheradresse fr Programm
        mov     sp,     #7fh    ;Stack im indirekt-adr.int.RAM ab 80h
        acall   serini          ;Initialisierung serielle Schnittstelle

Haupt:  mov     r7,#255         ;Zhler fr Verzgerung
w1:     mov     r6,#255
w2:     jnb     ri,w3           ;Zeichen empfangen?
        acall   text
w3:     djnz    r6,w2        
        djnz    r7,w1
        cpl     p1.0
        sjmp    Haupt

text:   mov     r5,sbuf         ;Zeichen retten
        clr     ri
        mov     dptr,#text1     ;DatenZeiger auf Text setzen
        acall   seraus          ;Serielle Ausgabe aufrufen
        mov     a,r5
w_t:    jnb     ti,w_t          ;warten bis Sende-Schieberegister leer
        mov     sbuf,a          ;... nchstes Zeichen -> Schieberegister
        clr     ti              ;TransferEnde-Bit lschen und ...
        ret

;------ UP fr RS232-Initialisierung: 9600Bd, 8data, no parity, 1stop
serini: anl     tmod,   #0fh    ;Init serielle Schnittstelle mit Timer1
        orl     tmod,   #20h    ;... im Reload-Modus
        mov     th1,    #256-13 ;... Reload-Wert fr Timer1     (256-13) 
        orl     pcon,   #80h    ;... smod=1  9600Bd <- osz/(12*1*16 *13)
        mov     scon,   #5Ah    ;... Init RS232
        setb    ti              ;... scon.1, sendebereit
        setb    tr1             ;... Timer 1 ein
        ret

;------ UP fr RS232-Textausgabe: Textanfang im DPTR & letztes Textzeichen ...
seraus:                         ;... muss 00h (ASCII: NUL) sein!
        clr     a               ;Akku fr Ladebefehl lschen
        movc    a,@a+dptr       ;nchstes Zeichen aus dem Codespeicher holen
w_ti:   jnb     ti,w_ti         ;warten bis Sende-Schieberegister leer
        mov     sbuf,a          ;... nchstes Zeichen -> Schieberegister
        clr     ti              ;TransferEnde-Bit lschen und ...
        inc     dptr            ;Zeiger fr Ausgabezeichen erhhen
        jnz     seraus          ;wdhl. solange Zeichen nicht 00h war
        ret
        
text1:  db      0dh,0ah,'Hallo, das war ein ',0 ;letztes Z.:00h

        end
