REM Programmierung AT89S8252  LPTx -> SPI   2000-08-23 Da - l/ 2000-10-17 Da
REM
REM Verbindung: LPTx/25pol.SUB-D D0 Pin2 -> MOSI P1.5 Pin6 PDIP-Gehuse
REM                              D2 Pin4 -> RST Reset Pin9
REM                              D3 Pin5 -> SCK  P1.7 Pin8
REM                           BUSY Pin11 <- MISO P1.6 Pin7
REM

DECLARE SUB BefZeile (lpt%, datei$, Argte$())
DECLARE SUB ParaDein (lpt%, Zzahl&, para%)
DECLARE SUB ParaDaus (lpt%, Zzahl&, para%)
DECLARE SUB LPTx (P%, pdat%, pcin%, pctl%)
DECLARE SUB Pini (pdat%, pcin%, zeit!, clr$)
DECLARE SUB Transfer (pdat%, pcin%, zeit!, mem%, byte%, ok%)
DECLARE SUB SEND (pdat%, pcin%, da%, zeit!)
DECLARE SUB LIES (pdat%, pcin%, da%, zeit!)
DECLARE SUB ZBASIS (zeit!, Zzahl&, para%)
DECLARE SUB WARTE (zeit!)
DECLARE SUB ZBIN (zahl%, zb%())
DECLARE FUNCTION BIN$ (zahl%)
 
DIM Buffer%(0 TO 8200)
DIM Baktiv%(0 TO 8200)
DIM bytes%(1 TO 80)
DIM Argte$(1 TO 3)

  CALL BefZeile(lpt%, datei$, Argte$())
  CALL ParaDein(lpt%, Zzahl&, para%)
  CALL LPTx(lpt%, pdat%, pcin%, pctl%)
  CALL ZBASIS(zeit!, Zzahl&, para%)
  CALL ParaDaus(lpt%, Zzahl&, para%)

  VIEW PRINT 5 TO 24: CLS
  LOCATE 5, 6: PRINT "                                             "
  i = 0
datei:
  IF datei$ = "" THEN
    DO
      LOCATE 5, 6: PRINT TAB(70);
      LOCATE 5, 6: PRINT "INTEL-HEX Datei:         .HEX";
      LOCATE 5, 22: INPUT " ", datei$
      datei$ = datei$ + ".hex"
      i = i + 1
    LOOP UNTIL LEN(datei$) <= 12 AND LEN(datei$) >= 5 OR i > 2
  END IF
  IF i > 2 THEN GOTO Terminal
  ON ERROR GOTO Dateifehler
  OPEN datei$ FOR INPUT AS #1
  ON ERROR GOTO 0
  CLOSE #1
  LOCATE 5, 6: PRINT UCASE$(datei$); " wird gesendet ..."; TAB(70);
 
  LOCATE 6, 6: PRINT " ... vorher den Speicher komplett lschen (J/N)? ";
  DO: clr$ = UCASE$(INKEY$): LOOP UNTIL clr$ = "J" OR clr$ = "N"
  PRINT clr$
 
  VIEW PRINT 8 TO 24: CLS
  PRINT "      Datei einlesen / Daten bearbeiten ";
  OPEN datei$ FOR INPUT AS #1
  DO WHILE NOT (EOF(1))
    INPUT #1, a$
    IF LEFT$(a$, 1) = ":" THEN
      anz% = VAL("&H" + MID$(a$, 2, 2))
      mem% = VAL("&H" + MID$(a$, 4, 4))
      FOR i = 1 TO anz%
        Buffer%(mem%) = VAL("&H" + MID$(a$, 8 + i + i, 2))
        Baktiv%(mem%) = 1
        mem% = mem% + 1
      NEXT i
    END IF
  LOOP
 
  PRINT "... programmieren": PRINT
  CALL Pini(pdat%, pcin%, zeit!, clr$)
  zei% = 0: zae% = 0
  FOR mem% = 0 TO 8200
    SELECT CASE Baktiv%(mem%)
      CASE 0
        IF zei% = 1 THEN PRINT
        zei% = 0: zae% = 0
      CASE 1
        IF zei% = 0 THEN PRINT USING " \  \ "; HEX$(mem%); : zei% = 1
        byte% = Buffer%(mem%)
        CALL Transfer(pdat%, pcin%, zeit!, mem%, byte%, ok%)
        IF ok% = 0 THEN EXIT FOR
        zae% = zae% + 1: IF zae% > 31 THEN PRINT : zei% = 0: zae% = 0
    END SELECT
  NEXT mem%

Terminal:
  OUT pdat%, 0                  ' RST, SCK, MOSI -> low
  CLOSE
  PRINT : PRINT
  PRINT "      Terminalprogramm  PC <-V24-> C  starten (J/N)? ";
  DO: clr$ = UCASE$(INKEY$): LOOP UNTIL clr$ = "J" OR clr$ = "N"
  PRINT clr$
  IF clr$ = "J" THEN
    COLOR 15, 1
    CLS
    SHELL "term.exe"
  END IF

END

Dateifehler:
  IF ERR = 53 THEN
    LOCATE 5, 38: PRINT "Datei nicht gefunden!!"
    datei$ = ""
    t = TIMER + 2: DO: LOOP UNTIL TIMER > t
    RESUME datei:
  ELSE
    RESUME NEXT
  END IF

Parameterdateifehler:
  para% = 0
  RESUME NEXT

SUB BefZeile (lpt%, datei$, Argte$())
  CONST WAHR% = -1, FALSCH% = 0
  AnzArgte% = 0: In% = FALSCH%: MaxArgte% = 2
  Cl$ = COMMAND$
  l% = LEN(Cl$)
  FOR i = 1 TO l%
    C$ = MID$(Cl$, i, 1)
    IF (C$ <> " " AND C$ <> CHR$(9)) THEN
      IF NOT In% THEN
         IF AnzArgte% = MaxArgte% THEN EXIT FOR
         AnzArgte% = AnzArgte% + 1
         In% = WAHR%
      END IF
      Argte$(AnzArgte%) = Argte$(AnzArgte%) + C$
      ELSE
      In% = FALSCH%
    END IF
  NEXT i
  lpt% = 0
  FOR i = 1 TO MaxArgte%
    a$ = Argte$(i)
    Frage% = LEN(a$) = 5 AND UCASE$(LEFT$(a$, 4)) = "-LPT"
    IF (Frage% AND (RIGHT$(a$, 1) = "1" OR RIGHT$(a$, 1) = "2")) THEN
      lpt% = VAL(RIGHT$(a$, 1))
      Argte$(i) = ""
    END IF
  NEXT i
  datei$ = ""
  FOR i = 1 TO MaxArgte%
  a$ = Argte$(i): l% = LEN(a$)
    SELECT CASE l%
      CASE 1 TO 4
        datei$ = a$ + ".HEX"
      CASE 5 TO 8
        IF MID$(a$, l% - 3, 1) = "." THEN
          datei$ = a$
        ELSE
          datei$ = a$ + ".hex"
        END IF
      CASE 9 TO 12
        IF MID$(a$, l% - 3, 1) = "." THEN datei$ = a$
      CASE IS > 12
        IF MID$(a$, 2, 2) = ":\" THEN
          IF MID$(a$, l% - 3, 1) = "." THEN
            datei$ = LEFT$(a$, l% - 3) + "hex"
          ELSEIF MID$(a$, l% - 2, 1) = "." THEN
            datei$ = LEFT$(a$, l% - 2) + "hex"
          ELSEIF MID$(a$, l% - 1, 1) = "." THEN
            datei$ = LEFT$(a$, l% - 1) + "hex"
          ELSE
            datei$ = a$ + ".hex"
          END IF
        END IF
    END SELECT
  NEXT i
END SUB

FUNCTION BIN$ (zahl%)
   b$ = ""
   z% = zahl%
   IF z% < 0 THEN z% = z% + 256
   IF z% < 256 THEN
      q% = 128
      DO WHILE q% >= 1
         IF (z% / q%) >= 1 THEN
            b$ = b$ + "1"
            z% = z% - q%
         ELSE
            b$ = b$ + "0"
         END IF
         q% = q% / 2
      LOOP
   END IF
   BIN$ = b$
END FUNCTION

SUB LIES (pdat%, pcin%, da%, zeit!)
DIM b%(0 TO 7)
    FOR i = 7 TO 0 STEP -1
      d% = 4                          'MOSI-0, RST-1, SCK-0
      OUT pdat%, d%
      CALL WARTE(zeit!)
      OUT pdat%, d% + 8               'SCK -> High    ... takten
      CALL WARTE(zeit!)
      i% = INP(pcin%): b%(i) = 1
      IF FIX(i% / 128) > 0 THEN b%(i) = 0
      OUT pdat%, d%                   'SCK -> Low
      CALL WARTE(zeit!)
    NEXT i
    da% = (b%(7) * 128) + (b%(6) * 64) + (b%(5) * 32) + (b%(4) * 16)
    da% = (b%(3) * 8) + (b%(2) * 4) + (b%(1) * 2) + b%(0) + da%
END SUB

SUB LPTx (P%, pdat%, pcin%, pctl%)
   COLOR 15, 1          'Parallelport feststellen ... initialisieren
   CLS : LOCATE 3, 6
   IF P% = 0 THEN
    PRINT "LPT 1  oder  LPT 2 : (1/2) ? "
    DO: P$ = INKEY$: P% = VAL(P$)
    LOOP UNTIL P% = 1 OR P% = 2
   END IF
   DEF SEG = 0
   IF P% = 1 THEN pdat% = PEEK(&H408) + 256 * PEEK(&H409)
   IF P% = 2 THEN pdat% = PEEK(&H40A) + 256 * PEEK(&H40B)
   CLS : LOCATE 3, 6:
   PRINT "Parallelport LPT"; P%; "(hex/dez) : "; HEX$(pdat%); " /"; pdat%;
   PRINT "    Zeitbasis:"
   DEF SEG
   pcin% = pdat% + 1
   pctl% = pdat% + 2
   OUT pdat%, &H0                      'Ausgnge -> Low
   OUT pcin%, &H0                      'Steuerbyte
   OUT pctl%, &H0                      'Steuerbyte: Grundzustand
END SUB

SUB ParaDaus (lpt%, Zzahl&, para%)
  OPEN "Atmel51.par" FOR OUTPUT AS #1
  PRINT #1, lpt%
  PRINT #1, Zzahl&
  PRINT #1, FIX(Zzahl& / 3.14)
  PRINT #1, "1.Zeile: LPTx, 2.Zeile: Zhlergebnis fr 5s, 3.Zeile Kontollzahl"
  CLOSE #1
END SUB

SUB ParaDein (lpt%, Zzahl&, para%)
  para% = 1                       'Parameterdatei vorhanden - sonst para% = 0
  ON ERROR GOTO Parameterdateifehler
  OPEN "Atmel51.par" FOR INPUT AS #1
  INPUT #1, l%
  INPUT #1, zeitzahl&
  INPUT #1, zeitsicher&
  IF l% = 1 OR l% = 2 THEN
    zs& = FIX(zeitzahl& / 3.14)
    IF zeitsicher& = zs& THEN
      IF lpt% < 1 OR lpt% > 2 THEN lpt% = l%
      Zzahl& = zeitzahl&
    ELSE
      KILL "Atmel51.par": para% = 0
    END IF
  ELSE
    para% = 0
  END IF
  ON ERROR GOTO 0
  CLOSE
END SUB

SUB Pini (pdat%, pcin%, zeit!, clr$)    ' Initialisierungscode
  OUT pdat%, 4                  ' RST -> high, SCK -> low, MOSI -> low
  CALL WARTE(zeit! * 10)        '
  OUT pdat%, 0                  '  einmal mit RST wackeln nach
  CALL WARTE(zeit! * 10)        '  ERRATA SHEET AT89(L)S8252
  OUT pdat%, 4                  '
  CALL WARTE(zeit! * 10000)     ' 1/10s warten
  da% = &HAC                    ' Programming Enable: >AC< 53 xx
  CALL SEND(pdat%, pcin%, da%, zeit!)
  da% = &H53                    ' Programming Enable: AC >53< xx
  CALL SEND(pdat%, pcin%, da%, zeit!)
  da% = &H0                     ' Programming Enable: AC 53 >xx<
  CALL SEND(pdat%, pcin%, da%, zeit!)
  CALL WARTE(zeit! * 10000)     ' 1/10s warten
  IF clr$ = "J" THEN
    da% = &HAC                    ' Chip Erase: >AC< x4 xx
    CALL SEND(pdat%, pcin%, da%, zeit!)
    da% = &H4                     ' Chip Erase: AC >x4< xx
    CALL SEND(pdat%, pcin%, da%, zeit!)
    da% = &H0                     ' Chip Erase: AC x4 >xx<
    CALL SEND(pdat%, pcin%, da%, zeit!)
    CALL WARTE(zeit! * 50000)     ' 1/2s warten
  END IF
END SUB

SUB SEND (pdat%, pcin%, da%, zeit!)
DIM dab%(0 TO 7)
    da$ = BIN$(da%): CALL ZBIN(da%, dab%())
    FOR i = 7 TO 0 STEP -1
      d% = dab%(i) + 4                'D0 -> MOSI, RST-1, SCK-0
      OUT pdat%, d%                   'Bit auf MOSI
      CALL WARTE(zeit!)
      OUT pdat%, d% + 8               'SCK -> High    ... speichern
      CALL WARTE(zeit!)
      OUT pdat%, d%                   'SCK -> Low
      CALL WARTE(zeit!)
    NEXT i
END SUB

SUB Transfer (pdat%, pcin%, zeit!, mem%, byte%, ok%)
  high% = FIX(mem% / 256): low% = mem% MOD 256
  wri% = high% * 8 + 2            'Write Code: aaaa a010; aaaa a - 5MSBs
  rea% = high% * 8 + 1            'Read Code:  aaaa a001; aaaa a - 5MSBs
  da% = wri%
  CALL SEND(pdat%, pcin%, da%, zeit!)    'Write Code
  da% = low%
  CALL SEND(pdat%, pcin%, da%, zeit!)    'Low Adress-Byte
  da% = byte%
  CALL SEND(pdat%, pcin%, da%, zeit!)    'Datenbyte
  ok% = 0
  ende = TIMER + 1                      'Warten auf Programmierende
  DO                                    'gelesenes Byte = programmiertes
    da% = rea%                          'oder Zeit abgelaufen
    CALL SEND(pdat%, pcin%, da%, zeit!)    'Read Code
    da% = low%
    CALL SEND(pdat%, pcin%, da%, zeit!)    'Low Adress-Byte
    da% = 0
    CALL LIES(pdat%, pcin%, da%, zeit!)    'Takt fr Lesen
  LOOP UNTIL da% = byte% OR TIMER > ende
  SELECT CASE da%
    CASE IS = byte%
      ok% = 1
      IF LEN(HEX$(byte%)) < 2 THEN PRINT "0";   'Anzeige Byte ok
      PRINT HEX$(byte%);
    CASE IS <> byte%
      ok% = 0: PRINT
      PRINT "      ****   Programmierfehler!   ****"
  END SELECT
END SUB

SUB WARTE (zeit!) 'Warteschleife unabhngig von der Prozessorgeschwindigkeit
   y& = 0         'mit denselben Funktionen/Variablen wie beim ersten Zhlen
   DO: y& = y& + 1: x = TIMER: LOOP UNTIL y& > zeit!
END SUB

SUB ZBASIS (zeit!, Zzahl&, para%)
  IF para% = 0 THEN
    PRINT TAB(8); "Zeitbasis wird ermittelt: 5 s Zhlen ";
    x = TIMER + 5: y& = 0
    DO: y& = y& + 1: LOOP UNTIL TIMER > x
    Zzahl& = y&
  ELSE
    y& = Zzahl&
  END IF
  LOCATE CSRLIN, 1: PRINT TAB(51); "->"; y&;
  zeit = y& / 500000      'Zeitbasis: 10 s (5s/500000)
  PRINT zeit
END SUB

SUB ZBIN (zahl%, zb%())
   z% = zahl%
   IF z% < 0 THEN z% = z% + 256
   IF z% < 256 THEN
      q% = 128: P% = 7
      DO WHILE q% >= 1
         IF (z% / q%) >= 1 THEN
            zb%(P%) = 1
            z% = z% - q%
         ELSE
            zb%(P%) = 0
         END IF
         q% = q% / 2: P% = P% - 1
      LOOP
   END IF
END SUB

