$DEBUG

;mit Schaltern zur Reduktion des Codes: GSET 1 - Code wird genutzt
;                                       GSET 0 - Code wird nicht genutzt und weggelassen
;  (Zuweisungen mit GSET - auch bedingt - brauchen keinen Speicherplatz!)

SerSBUF	GSET	1	;Serielle Schnittstelle mit SBUF	0
LCDP	GSET	1	;LCDisplay an Portx     		1
S_UART	GSET	0	;Soft-UART an Portpin (KSC-Debugger)	2
UserDef	GSET	0	;Anwender-definierte Ein-/Ausgaben	3,4
			;Fuer VAL-Prozedur! nicht weglassen!	5,6
P80517	GSET	0	;Serial 1 des 80C517/537		7
P80320	GSET	0	;Serial 1 des 80C320			8

;source text for IODRIVERS with different character writing (WRITC)
; and character reading (READC) routines
;870712 KSC Software Systems
;880430 corrected for use in version 2.0
;890418 corrected for conditional assembly of soft uart characteristics.
;890703 corrected for use in version 3.0
;891114 corrected for version 3.05b
;900622 additions for SYS517
;910529 further additions for SYS517
;940301 additions for Dallas 80C320 Serial1

; global settings of clock frequency and baudrate for SOFT uart:
; CLOCKRATE might be 11 (11.0592 MHz) or 12 (12.0 MHz)
; BAUDRATE might be 1200, 2400, 4800 and 9600 (last only exact enough at 11.0592 MHz)
; NO_OF_BITS might be 7 or 8
; NO_OF_STOPS might be 1 or 2


; !!!! NB! CHANGE THESE NEXT SETTINGS TO SUIT YOUR NEEDS   !!!

CLOCKRATE	GSET	11				;-----------------S_UART
BAUDRATE	GSET	1200
NO_OF_BITS	GSET	7
NO_OF_STOPS	GSET	1

IF CLOCKRATE=11
 IF BAUDRATE=9600
   RATE	GSET	42
 ENDIF
 IF BAUDRATE=4800
  RATE	GSET	90  
 ENDIF
 IF (BAUDRATE=2400)!(BAUDRATE=1200)
  RATE	GSET	186
 ENDIF
 IF     0	; dummy if statement
 ENDIF
ELSE
 IF BAUDRATE=9600
  RATE	GSET	46
 ENDIF
 IF BAUDRATE=4800
  RATE	GSET	98
 ENDIF
 IF (BAUDRATE=2400)!(BAUDRATE=1200)
  RATE	GSET	202
 ENDIF
ENDIF	;----------------------------------------------------------------------			

SYS517  GSET    0FFFFH					;----------------P80517
IF	SYS517
 S1CON	GSET	9BH
 S1BUF	GSET	9CH
 S1REL	GSET	9DH
ENDIF	;----------------------------------------------------------------------


;******************************************************************************
LIBRARY	READC

; READC reads one character from a selected device or string
; at call:  I/O channel number in ?DEVICE; the character is returned in R2,
; the channels are:
;               O: The serial port SBUF, the character is ecchoed.
;               2: A soft-uart using one port bit INBIT;
;		   initially set to P3.2.
;                  For baudrate etc., see global setting at top of file.
;               3,4: Two user defined routines USRREAD0 and USRREAD1
;               5,6: Those routines are used by the procedure VAL and must not
;		     be changed.
;               7: If you are using the Siemens 80C517 or 80C537 this channel
;                  may be SERIAL1
;               8: The Dallas 80C320 serial port SBUF1, the character is ecchoed.


PUBLIC ?READC

EXTRN	CODE	( ?WRITC )
EXTRN	DATA	( ?AR0, ?AR4, ?DEVICE)
?READC?C	SEGMENT	CODE
RSEG	?READC?C

INBIT		BIT	P3.2	; defines Port3 bit 2 as SOFT UART in bit

?READC:	MOV     A,?DEVICE
IF SerSBUF=1						;-----------------SerSBUF
        JZ      READ0
ENDIF	;----------------------------------------------------------------------
        DEC     A
        DEC     A
IF S_UART=1						;-----------------S_UART
        JZ      READ2
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF UserDef=1						;-----------------UserDef
        JZ      USRREAD0
ENDIF
	DEC	A
IF UserDef=1
        JZ      USRREAD1
ENDIF	;----------------------------------------------------------------------
        DEC     A
	JZ	READ5
	DEC	A
	JZ	READ6
	DEC	A
IF P80517=1						;-----------------P80517
	JZ	READ7
ENDIF	;----------------------------------------------------------------------
	
IF P80320=1						;-----------------P80320
READ8:	JNB	0C0H,READ8	; DS 80C320 Serial1 uart
	CLR	0C0H		; RI1
	MOV	A,0C1H		; SBUF1
	MOV	R2,A
	SUBB	A,#0DH
	JZ	$+5
	CALL	?WRITC
ENDIF	;----------------------------------------------------------------------
	RET

IF P80517=1						;-----------------P80517
READ7:	MOV	A,S1CON		; Siemens 80C517 Serial1 uart
	JNB	ACC.0,READ7
	CLR	ACC.0
	MOV	S1CON,A
	MOV	R2,S1BUF
	RET
ENDIF	;----------------------------------------------------------------------

READ6:  DEC	?AR4		; These routines are for the VAL procedure
	MOV	A,?AR4		; and must not be changed
	JZ	RETCR
	MOVX	A,@DPTR
	INC	DPTR
	MOV	R2,A
	RET

RETCR:	MOV	R2,#13
	RET

READ5:	DEC	?AR4		; These routines are for the VAL procedure
	MOV	A,?AR4		; and must not be changed
	JZ	RETCR
	MOV	R0,?AR0
	MOV	A,@R0
	INC	?AR0
	MOV	R2,A
	RET

IF SerSBUF=1						;-----------------SerSBUF
READ0:	JNB	98H,READ0	; Serial uart
	CLR	98H
	MOV	A,SBUF
	MOV	R2,A
	SUBB	A,#0DH
	JZ	$+5
	CALL	?WRITC
	RET
ENDIF	;----------------------------------------------------------------------

IF S_UART=1						;-----------------S_UART
READ2:  SETB	EA
	JB	INBIT,READ2	; Soft uart; wait communication
	CLR	EA
  IF	BAUDRATE=1200
	MOV	R5,#RATE
  ELSE
	MOV	R5,#RATE/2	; half bit wait time
  ENDIF
READ2A:	DJNZ	R5,READ2A
	JB	INBIT,READ2	; try again if error
	MOV	R2,#NO_OF_BITS
	CLR	C
READ2B:	CALL	ONEBIT
  IF	BAUDRATE=1200
	CALL	ONEBIT
  ENDIF
	RRC	A
	MOV	C,INBIT
	DJNZ	R2,READ2B
	RRC	A
  IF	NO_OF_BITS=7
	CLR	C
	RRC	A		; 8 shifts total needed
  ENDIF
	CALL	ONEBIT		;first stop bit detected
	MOV	R2,A
	SETB	EA
	RET

ONEBIT:	MOV	R5,#RATE
ONEBIT1:
	DJNZ	R5,ONEBIT1
	RET
ENDIF	;----------------------------------------------------------------------

IF UserDef=1						;-----------------UserDef
USRREAD0:		; You are supposed to put your user0-code here
	RET
USRREAD1:		; and ditto user1-code.
	RET
ENDIF	;----------------------------------------------------------------------


LIBEND



;******************************************************************************
LIBRARY	WRITC

; WRITC writes one character to a selected device or string
; at call: the character must be in R2, I/O channel number in ?DEVICE
; the channels are:
;               O: The serial port SBUF
;               1: A parallel display like a SANYO LCM 5xx
;		   connected at PortX SFR-address LCDxx
;               2: A soft-uart using one port bit OUTBIT;
;		   initially set to P3.5.
;		   Baud rate settings according to file header
;               3,4: Two user defined routines USRWRIT0 and USRWRIT1
;               5,6: Those routines are used by the procedure STR and must not
;		     be changed.
;               7:  If using the Siemens 80C517 or 80C537 this will be SERIAL1
;		8:  If using the DS 80C320 this will be SERIAL1


PUBLIC	?WRITC, ?DEVICE, ?AR0, ?AR4
?WRITC?C	SEGMENT	CODE
?WRITC?D	SEGMENT	DATA

RSEG	?WRITC?D

?DEVICE:
	DS	1
?AR0:	DS	1
?AR4:	DS	1

RSEG	?WRITC?C

OUTBIT		EQU	P3.5	; defines Port3 bit 5 as soft uart out bit
LCD             EQU     P2      ;hier Port fuer LCD-Anschluss angeben!
                                ;Datenleitungen: LCD.7 ... LCD.4
LCD_E           EQU     LCD.3   ;Enable
LCD_RW          EQU     LCD.2   ;Schreiben oder Lesen
LCD_RS          EQU     LCD.1   ;Kommando oder Daten
LCD_K           EQU     LCD.0   ;Kontrast

?WRITC:	MOV     A,?DEVICE
IF SerSBUF=1						;-----------------SerSBUF
        JZ      WRIT0
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF LCDP=1						;-----------------LCD
        JZ      WRIT1
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF S_UART=1						;-----------------S_UART
        JZ      WRIT2
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF UserDef=1						;-----------------UserDef
        JZ      USRWRIT0
ENDIF
	DEC	A
IF UserDef=1
        JZ      USRWRIT1
ENDIF	;----------------------------------------------------------------------
        DEC     A
	JZ	WRIT5
	DEC	A
	JZ	WRIT6
	DEC	A
IF P80517=1						;-----------------P80517
	JZ	WRIT7
ENDIF	;----------------------------------------------------------------------

IF P80320=1						;-----------------P80320
WRIT8:	JNB	0C1H,WRIT8	; using SBUF1
	MOV	A,R2
	MOV	0C1H,A		; SBUF1
	CLR	0C1H		; TI1
ENDIF	;----------------------------------------------------------------------
	RET

IF P80517=1						;-----------------P80517
WRIT7:	MOV	A,S1CON
	JNB	ACC.1,WRIT7
	CLR	ACC.1
	MOV	S1CON,A
	MOV	S1BUF,R2
	RET
ENDIF	;----------------------------------------------------------------------
	
WRIT6:	MOV	A,R2	; For string operation, external RAM
	MOVX	@DPTR,A
	INC	DPTR
	INC	?AR4
	RET
	
WRIT5:	MOV	A,R2	; For string operation, internal RAM
	MOV	R0,?AR0
	MOV	@R0,A
	INC	?AR0
	INC	?AR4
	RET

IF SerSBUF=1						;-----------------SerSBUF
WRIT0:	JNB	TI,WRIT0	; using SBUF
	MOV	A,R2
	MOV	SBUF,A
	CLR	TI
	RET
ENDIF	;----------------------------------------------------------------------

IF LCDP=1						;-----------------LCD
WRIT1:	MOV	A,R2	; LC-Display (Hitachi)an Port: 4Bit-Mode
	CJNE    A,#0Dh,WRIT10   ;wenn CR (Wagenruecklauf) ...
        MOV     A,#02h          ;... dann Kommando: cursor home
        SJMP    COM_O
WRIT10:	CJNE    A,#09h,WRIT11   ;wenn HT (Tabulator) ...
        MOV     A,#80h+40h      ;... dann zweite Zeile: Adresse 40H
        SJMP    COM_O
WRIT11: MOV     C,ACC.7         ;andere Steuerzeichen (<20h) ...
        ORL     C,ACC.6
        ORL     C,ACC.5
        JC      DAT_O
        RET                     ;... werden nicht ausgegeben
DAT_O:  SETB    LCD_RS          ; Ausgabe Datenbyte
        SJMP    OUT2
COM_O:  CLR     LCD_RS          ; Ausgabe Kommandobyte
OUT2:   PUSH    ACC
        LCALL   W_LCD           ; erstes Halbbyte
        POP     ACC
        SWAP    A
OUT1:   LCALL   W_LCD           ; zweites Halbbyte ... 
WT_BSY: ORL     LCD,#0F0H       ;       use Bits 4..7 as inputs
        SETB    LCD_RW          ;       read mode
        CLR     LCD_RS          ;       command
        SETB    LCD_E           ;       strobe on
        MOV     A,LCD           ;       first read
        CLR     LCD_E           ;       strobe off
        SETB    LCD_E           ;       second read
        CLR     LCD_E           ;       dont transfer - Bit 7 is busy bit
        JB      ACC.7,WT_BSY    ; ... warten auf LCD fertig
        RET
W_LCD:  CLR     LCD_RW          ; linkes Halbbyte aus Akku -> LCD
        ANL     A,#0F0H
        ANL     LCD,#0FH
        ORL     LCD,A           ;       set data bits
        SETB    LCD_E           ;       strobe
        CLR     LCD_E
        RET
ENDIF	;----------------------------------------------------------------------

IF S_UART=1						;-----------------S_UART
WRIT2:	CLR	EA		; don't let interrupts spoil your UART.
	CLR	OUTBIT	; startbit
	CALL	ONEBIT
 IF	BAUDRATE=1200
	CALL	ONEBIT
 ENDIF
	MOV	R4,#NO_OF_BITS
WRIT20:	MOV	A,R2
	RRC	A
	MOV	R2,A
	MOV	OUTBIT,C	; databit
	CALL	ONEBIT
 IF	BAUDRATE=1200
	CALL	ONEBIT
 ENDIF
	DJNZ	R4,WRIT20
	SETB	OUTBIT
	CALL	ONEBIT
 IF	BAUDRATE=1200
	CALL	ONEBIT
 ENDIF
 IF	NO_OF_STOPS=2
	CALL	ONEBIT		; 2 stop bits
  IF BAUDRATE=1200
 	CALL	ONEBIT
  ENDIF
 ENDIF
	SETB	EA
	RET
ONEBIT:	MOV	R5,#RATE
	DJNZ	R5,$
	RET
ENDIF	;----------------------------------------------------------------------

IF UserDef=1						;-----------------UserDef
USRWRIT0:				; To be filled out by user
	RET
USRWRIT1:				; To be filled out by user
	RET
ENDIF	;----------------------------------------------------------------------


LIBEND


;******************************************************************************
LIBRARY RESET

PUBLIC ?RESET

?RESET?C	SEGMENT	CODE

RSEG	?RESET?C

LCD             EQU     P2      ;hier Port fuer LCD-Anschluss angeben!
                                ;Datenleitungen: LCD.7 ... LCD.4
LCD_E           EQU     LCD.3   ;Enable
LCD_RW          EQU     LCD.2   ;Schreiben oder Lesen
LCD_RS          EQU     LCD.1   ;Kommando oder Daten
LCD_K           EQU     LCD.0   ;Kontrast

?RESET: MOV	A,R3
IF SerSBUF=1						;-----------------SerSBUF
	JZ	RESET0
ENDIF	;----------------------------------------------------------------------

IF LCDP=1						;-----------------LCD
	CJNE	A,#1,RESET7
RESET2: LCALL   WT_BSY          ; warten auf LCD fertig
        MOV     A,#00101000B    ;  4 bit mode
        LCALL   COM_O
        MOV     A,#00001100B    ;  display on, cursor off, blink off
        LCALL   COM_O
        MOV     A,#00000110B    ;  entry mode: increment, shift off
        LCALL   COM_O
        MOV     A,#00000001B    ;  clear display
        LCALL   COM_O
        CLR     LCD_K           ; Kontrast ein
        RET
COM_O:  CLR     LCD_RS          ; Ausgabe Kommandobyte
OUT2:   PUSH    ACC
        LCALL   W_LCD           ; erstes Halbbyte
        POP     ACC
        SWAP    A
OUT1:   LCALL   W_LCD           ; zweites Halbbyte ... 
WT_BSY: ORL     LCD,#0F0H       ;       use Bits 4..7 as inputs
        SETB    LCD_RW          ;       read mode
        CLR     LCD_RS          ;       command
        SETB    LCD_E           ;       strobe on
        MOV     A,LCD           ;       first read
        CLR     LCD_E           ;       strobe off
        SETB    LCD_E           ;       second read
        CLR     LCD_E           ;       dont transfer - Bit 7 is busy bit
        JB      ACC.7,WT_BSY    ; ... warten auf LCD fertig
        RET
W_LCD:  CLR     LCD_RW          ; linkes Halbbyte aus Akku -> LCD
        ANL     A,#0F0H
        ANL     LCD,#0FH
        ORL     LCD,A           ;       set data bits
        SETB    LCD_E           ;       strobe
        CLR     LCD_E
        RET
ENDIF	;----------------------------------------------------------------------

RESET7:
IF P80517=1						;-----------------P80517
	CJNE	A,#7,?RESET8
	MOV	S1REL,#220	; 9600 Baud @11.0592Mhz
	MOV	S1CON,#93H
	SJMP	RETURN
ENDIF	;----------------------------------------------------------------------

?RESET8:
IF P80320=1						;-----------------P80320
	CJNE	A,#8,RETURN
RESET8:	;code resets 80C320 SBUF1 to polling, 9600 Baud @11.0592 MHz CPU clock
	MOV	A,TMOD
	ANL	A,#0FH
	ADD	A,#20H
	MOV	TMOD,A
	CLR	0C7H	;SM0
	SETB	0C6H	;SM1
	MOV	TH1,#250
	SETB	TR1
	MOV	A,PCON
	ORL	A,#80H
	MOV	PCON,A
	SETB	0C4H	;REN1
	SETB	0C1H	;TI1
ENDIF	;----------------------------------------------------------------------
RETURN:	RET
	
IF SerSBUF=1						;-----------------SerSBUF
RESET0:	; this code resets SBUF to polling, 9600 Baud @11.0592 MHz CPU clock
	; and resets eof-bit (1)
	MOV	A,TMOD
	ANL	A,#0FH
	ADD	A,#20H
	MOV	TMOD,A
	CLR	SM0
	SETB	SM1
	MOV	TH1,#243	;#250 @11.0592 / #243 @24 MHz CPU clock *******
	SETB	TR1
	MOV	A,PCON
	ORL	A,#80H
	MOV	PCON,A
	SETB	REN
	SETB	TI
	CLR	1
	RET
ENDIF	;----------------------------------------------------------------------


LIBEND


;******************************************************************************
LIBRARY EOF

EOF?C	SEGMENT CODE

RSEG	EOF?C

PUBLIC ?EOF

?EOF:	MOV	A,R3
	JZ	EOF0
	RET
	
EOF0:	MOV	C,1
	RET

LIBEND
	

; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;  These two last library modules MUST be the last input for the LINK51.
;
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;******************************************************************************
LIBRARY ISTACK

PUBLIC	?INITISTACK

EXTRN DATA ( ?STACKPTR )

?ISTACK?I	SEGMENT	IDATA
?ISTACK?C	SEGMENT CODE

RSEG	?ISTACK?I

?ISTACKSTART:
	DS	1	; stack in upper part of internal memory
	
RSEG	?ISTACK?C

?INITISTACK:
	MOV	?STACKPTR,#?ISTACKSTART
	POP	0
	POP	1
	MOV	SP,?STACKPTR
	PUSH	1
	PUSH	0
	RET

LIBEND


;******************************************************************************
LIBRARY	STACK

PUBLIC	?STACKPTR
PUBLIC	?INITSTACK, ?E517
?STACK?D	SEGMENT	DATA
?STACK?C	SEGMENT	CODE
?STACK?B	SEGMENT	BIT

RSEG	?STACK?B

?E517:	DBIT	1

RSEG	?STACK?D

?STACKPTR:
	DS	1	; initial value for transfer
?STACKSTART:
	DS	1	; stack: rest of data memory

RSEG	?STACK?C

?INITSTACK:
	MOV	?STACKPTR,#?STACKSTART
	POP	0
	POP	1
	MOV	SP,?STACKPTR
	PUSH	1
	PUSH	0
	SETB	?E517
	RET
	
LIBEND

END
