$DEBUG

;Source fr IODRIVER.OBJ (KSC C-Compiler) berarbeitet 2001-01-05 Da

;mit Schaltern zur Reduktion des Codes: GSET 1 - Code wird genutzt
;                                       GSET 0 - Code wird nicht genutzt und weggelassen
;  (Zuweisungen mit GSET - auch bedingt - brauchen keinen Speicherplatz!)

SerSBUF	GSET	1	;Serielle Schnittstelle mit SBUF	0
LCDP	GSET	1	;LCDisplay an Portx     		1
S_UART	GSET	0	;Soft-UART an Portpin (KSC-Debugger)	2
                        ;Anwender-definierte Ein-/Ausgaben	3,4

			;Fuer sscanf-Prozedur! nicht weglassen!	5,6,7

;source text for IODRIVERS with different character writing (WRITC)
; and character reading (READC) routines
;870712 KSC Software Systems
;880430 corrected for use in version 2.0
;890418 corrected for conditional assembly of soft uart characteristics.
;890703 corrected for use in version 3.0
;891114 last correction for version 3.05b
;930603 corrected for use with SYS51C sprintf
;950512 corrected for use with SYS51C s51cio.h (ResetSerial(...))
;950825 corrected for use with Built-in sprintf()

; global settings of clock frequency and baudrate for SOFT uart:
; CLOCKRATE might be 11 (11.0592 MHz) or 12 (12.0 MHz)
; BAUDRATE might be 1200, 2400, 4800 and 9600 (last only exact enough at 11.0592 MHz)
; NO_OF_BITS might be 7 or 8
; NO_OF_STOPS might be 1 or 2


; !!!! NB! CHANGE THESE NEXT SETTINGS TO SUIT YOUR NEEDS FOR DEVICE SOFT   !!!

CLOCKRATE	GSET	11				;-----------------S_UART
BAUDRATE	GSET	1200
NO_OF_BITS	GSET	7
NO_OF_STOPS	GSET	1

IF	CLOCKRATE=11
 IF BAUDRATE=9600
  RATE	GSET	42
 ENDIF
 IF BAUDRATE=4800
  RATE	GSET	90
 ENDIF
 IF (BAUDRATE=2400)!(BAUDRATE=1200)
  RATE	GSET	186
 ENDIF
 IF     0	; dummy if statement
 ENDIF
ELSE
 IF BAUDRATE=9600
  RATE	GSET	46
 ENDIF
 IF BAUDRATE=4800
  RATE	GSET	98
 ENDIF
 IF (BAUDRATE=2400)!(BAUDRATE=1200)
  RATE	GSET	202
 ENDIF
ENDIF	;----------------------------------------------------------------------


;******************************************************************************
LIBRARY	READC

; READC reads one character from a selected device or string
; at call:  I/O channel number in ?DEVICE; the character is returned in R2,
; the channels are:
;               O: The serial port SBUF, the character is ecchoed.
;               2: A soft-uart using one port bit INBIT;
;		   initially set to P3.2.
;                  For baudrate etc., see global setting at top of file.
;               3,4: Two user defined routines USRREAD0 and USRREAD1
;               5,6,7: Those routines are used by the procedure sscanf and must
;		     not be changed.


PUBLIC ?READC

EXTRN	CODE	( ?WRITC )
EXTRN	DATA	( ?AR0, ?AR4, ?DEVICE)
?READC?C	SEGMENT	CODE
RSEG	?READC?C

INBIT		BIT	P3.2	; defines Port3 bit 2 as soft uart in bit

?READC:	MOV     A,?DEVICE
IF SerSBUF=1						;-----------------SerSBUF
        JZ      READ0
ENDIF	;----------------------------------------------------------------------
        DEC     A
        DEC     A
IF S_UART=1						;-----------------S_UART
        JZ      READ2
ENDIF	;----------------------------------------------------------------------
        DEC     A
        JZ      USRREAD0
	DEC	A
        JZ      USRREAD1
        DEC     A
	JZ	READ5
	DEC	A
	JZ	READ6
	
READ7:	PUSH	DPL		; These routines are for the sscanf function
	PUSH	DPH		; and must not be changed
	MOV	DPL,?AR0
	MOV	DPH,?AR4
	CLR	A
	MOVC	A,@A+DPTR
	INC	DPTR
	MOV	R2,A
	MOV	?AR4,DPH
	MOV	?AR0,DPL
	POP	DPH
	POP	DPL
	RET
	
READ6:  PUSH	DPL
	PUSH	DPH
	MOV	DPH,?AR4
	MOV	DPL,?AR0
	MOVX	A,@DPTR
	INC	DPTR
	MOV	R2,A
	MOV	?AR0,DPL
	MOV	?AR4,DPH
	POP	DPH
	POP	DPL
	RET

RETCR:	MOV	R2,#13
	RET

READ5:	MOV	R0,?AR0		; These routines are for the sscanf function
	MOV	A,@R0		; and must not be changed
	INC	?AR0
	MOV	R2,A
	RET

IF SerSBUF=1						;-----------------SerSBUF
READ0:	JNB	98H,READ0	; Serial uart
	CLR	98H
	MOV	A,SBUF
	MOV	R2,A
	SUBB	A,#0DH
	JZ	$+5
	CALL	?WRITC
	RET
ENDIF	;----------------------------------------------------------------------

IF S_UART=1						;-----------------S_UART
READ2:  SETB	EA
	JB	INBIT,READ2	; Soft uart; wait communication
	CLR	EA
	
IF	BAUDRATE=1200
	MOV	R5,#RATE
ELSE
	MOV	R5,#RATE/2	; half bit wait time
ENDIF

READ2A:	DJNZ	R5,READ2A
	JB	INBIT,READ2	; try again if error
	MOV	R2,#NO_OF_BITS
	CLR	C
READ2B:	CALL	ONEBIT
IF	BAUDRATE=1200
	CALL	ONEBIT
ENDIF
	RRC	A
	MOV	C,INBIT
	DJNZ	R2,READ2B
	RRC	A
	
IF	NO_OF_BITS=7
	CLR	C
	RRC	A		; 8 shifts total needed
ENDIF
	CALL	ONEBIT		;first stop bit detected
	MOV	R2,A
	SETB	EA
	RET

ONEBIT:	MOV	R5,#RATE
ONEBIT1:
	DJNZ	R5,ONEBIT1
	RET
ENDIF	;----------------------------------------------------------------------

USRREAD0:		; You are supposed to put your user0-code here
	RET
	
USRREAD1:		; and ditto user1-code.
	RET

LIBEND



;******************************************************************************
LIBRARY	WRITC

; WRITC writes one character to a selected device or string
; at call: the character must be in R2, I/O channel number in ?DEVICE
; the channels are:
;               O: The serial port SBUF
;               1: A parallel display like a SANYO LCM 5xx
;		   connected at PortX SFR-address LCDxx
;               2: A soft-uart using one port bit OUTBIT;
;		   initially set to P3.5.
;		   Baud rate settings according to file header
;               3,4: Two user defined routines USRWRIT0 and USRWRIT1
;               5,6: Those routines are used by the function sprintf and must
;		     not be changed.


PUBLIC	?WRITC, ?DEVICE, ?AR0, ?AR4, _DEVICE
?WRITC?C	SEGMENT	CODE
?WRITC?D	SEGMENT	DATA

RSEG	?WRITC?D

?DEVICE:
_DEVICE:
	DS	1
?AR0:	DS	1
?AR4:	DS	1

RSEG	?WRITC?C


OUTBIT		EQU	P3.5	; defines Port3 bit 5 as soft uart out bit

LCD             EQU     P2      ;hier Port fuer LCD-Anschluss angeben!
                                ;Datenleitungen: LCD.7 ... LCD.4
LCD_E           EQU     LCD.3   ;Enable
LCD_RW          EQU     LCD.2   ;Schreiben oder Lesen
LCD_RS          EQU     LCD.1   ;Kommando oder Daten

?WRITC:	MOV     A,?DEVICE
IF SerSBUF=1						;-----------------SerSBUF
        JZ      WRIT0
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF LCDP=1						;-----------------LCD
        JZ      WRIT1
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF S_UART=1						;-----------------S_UART
        JZ      WRIT2
ENDIF	;----------------------------------------------------------------------
        DEC     A
        JZ      USRWRIT0
	DEC	A
        JZ      USRWRIT1
        DEC     A
	JZ	WRIT5
	
WRIT6:
	PUSH	DPL
	PUSH	DPH
	MOV	A,R2	; For sprintf operation, xdata
	MOV	DPL,?AR0
	MOV	DPH,?AR4
	MOVX	@DPTR,A
	INC	DPTR
	CLR	A
	MOVX	@DPTR,A
	MOV	?AR0,DPL
	MOV	?AR4,DPH
	POP	DPH
	POP	DPL
	RET
	
WRIT5:	MOV	A,R0
	PUSH	ACC
	MOV	A,R2	; For sprintf operation, data
	MOV	R0,?AR0
	MOV	@R0,A
	INC	R0
	MOV	@R0,#0
	MOV	?AR0,R0
	POP	ACC
	MOV	R0,A
	RET

USRWRIT0:				; To be filled out by user
	RET

USRWRIT1:				; To be filled out by user
	RET

IF SerSBUF=1						;-----------------SerSBUF
WRIT0:	JNB	TI,WRIT0	; using SBUF
	MOV	A,R2
	MOV	SBUF,A
	CLR	TI
	RET
ENDIF	;----------------------------------------------------------------------

IF LCDP=1						;-----------------LCD
WRIT1:	MOV	A,R2	; LC-Display (Hitachi)an Port: 4Bit-Mode
	CJNE    A,#0Dh,WRIT10   ;wenn CR (Wagenruecklauf) ...
        MOV     A,#02h          ;... dann Kommando: cursor home
        SJMP    COM_O
WRIT10:	CJNE    A,#09h,WRIT11   ;wenn HT (Tabulator) ...
        MOV     A,#80h+40h      ;... dann zweite Zeile: Adresse 40H
        SJMP    COM_O
WRIT11: MOV     C,ACC.7         ;andere Steuerzeichen (<20h) ...
        ORL     C,ACC.6
        ORL     C,ACC.5
        JC      DAT_O
        RET                     ;... werden nicht ausgegeben
DAT_O:  SETB    LCD_RS          ; Ausgabe Datenbyte
        SJMP    OUT2
COM_O:  CLR     LCD_RS          ; Ausgabe Kommandobyte
OUT2:   MOV     R2,A            ; in R2 stand das auszugebende Zeichen
        LCALL   W_LCD           ; erstes Halbbyte
        MOV     A,R2
        SWAP    A
OUT1:   LCALL   W_LCD           ; zweites Halbbyte ... 
WT_BSY: MOV     R2,#0           ; TimeoutZaehler: 232 ok @24MHz (0=256)
WT_B1:  ORL     LCD,#0F0H       ;       use Bits 4..7 as inputs
        SETB    LCD_RW          ;       read mode
        CLR     LCD_RS          ;       command
        SETB    LCD_E           ;       strobe on
        MOV     A,LCD           ;       first read
        CLR     LCD_E           ;       strobe off
        SETB    LCD_E           ;       second read
        CLR     LCD_E           ;       dont transfer - Bit 7 is busy bit
        JNB     ACC.7,WT_B2     ; ... warten auf LCD fertig
        DJNZ    R2,WT_B1        ; Timeout
WT_B2:  RET
W_LCD:  CLR     LCD_RW          ; linkes Halbbyte aus Akku -> LCD
        ANL     A,#0F0H
        ANL     LCD,#0FH
        ORL     LCD,A           ;       set data bits
        SETB    LCD_E           ;       strobe
        CLR     LCD_E
        RET
ENDIF	;----------------------------------------------------------------------

IF S_UART=1						;-----------------S_UART
WRIT2:	CLR	EA		; don't let interrupts spoil your UART.
	CLR	OUTBIT	; startbit
	CALL	ONEBIT
IF	BAUDRATE=1200
	CALL	ONEBIT
ENDIF
	MOV	R4,#NO_OF_BITS
WRIT20:	MOV	A,R2
	RRC	A
	MOV	R2,A
	MOV	OUTBIT,C	; databit
	CALL	ONEBIT
IF	BAUDRATE=1200
	CALL	ONEBIT
ENDIF
	DJNZ	R4,WRIT20
	SETB	OUTBIT
	CALL	ONEBIT
IF	BAUDRATE=1200
	CALL	ONEBIT
ENDIF
IF	NO_OF_STOPS=2
	CALL	ONEBIT		; 2 stop bits
 IF BAUDRATE=1200
 	CALL	ONEBIT
 ENDIF
ENDIF
	SETB	EA
	RET
	
ONEBIT:	MOV	R5,#RATE
	DJNZ	R5,$
	RET
ENDIF	;----------------------------------------------------------------------

LIBEND


;******************************************************************************
LIBRARY RESET

PUBLIC ?RESET,?RSETSERIAL


?RESET?C	SEGMENT	CODE

RSEG	?RESET?C

LCD             EQU     P2      ;hier Port fuer LCD-Anschluss angeben!
                                ;Datenleitungen: LCD.7 ... LCD.4
LCD_E           EQU     LCD.3   ;Enable
LCD_RW          EQU     LCD.2   ;Schreiben oder Lesen
LCD_RS          EQU     LCD.1   ;Kommando oder Daten
LCD_K           EQU     LCD.0   ;Kontrast

?RESET: MOV	A,R3
IF SerSBUF=1						;-----------------SerSBUF
	JZ	RESET0
ENDIF	;----------------------------------------------------------------------
        DEC     A
IF LCDP=1						;-----------------LCD
        JZ      RESET1
ENDIF	;----------------------------------------------------------------------

; put reset code for user defined devices here, ACC contains the device number

	RET

RESET0:	; this code resets SBUF to polling, 9600 Baud @11.0592 MHz CPU clock
	; and resets eof-bit (1)
	MOV	R2,#243	        ;#250 @11.0592 / #243 @24 MHz CPU clock *******
?RSETSERIAL:
IF SerSBUF=1						;-----------------SerSBUF
	MOV	A,TMOD
	ANL	A,#0FH
	ADD	A,#20H
	MOV	TMOD,A
	CLR	SM0
	SETB	SM1
	MOV	TH1,#243	;#250 @11.0592 / #243 @24 MHz CPU clock *******
	SETB	TR1
	MOV	A,PCON
	ORL	A,#80H
	MOV	PCON,A
	SETB	REN
	SETB	TI
	CLR	1
ENDIF	;----------------------------------------------------------------------
	RET

IF LCDP=1						;-----------------LCD
RESET1:	LCALL   WT_BSY          ; warten auf LCD fertig
        MOV     A,#00101000B    ;  4 bit mode
        LCALL   COM_O
        MOV     A,#00001100B    ;  display on, cursor off, blink off
        LCALL   COM_O
        MOV     A,#00000110B    ;  entry mode: increment, shift off
        LCALL   COM_O
        MOV     A,#00000001B    ;  clear display
        LCALL   COM_O
        CLR     LCD_K           ; LC-Display Kontrast einschalten
        RET
COM_O:  CLR     LCD_RS          ; Ausgabe Kommandobyte
OUT2:   MOV     R3,A            ; in R3 stand die Nr. des Ausgabekanals
        LCALL   W_LCD           ; erstes Halbbyte
        MOV     A,R3
        SWAP    A
OUT1:   LCALL   W_LCD           ; zweites Halbbyte ... 
WT_BSY: MOV     R3,#0           ; TimeoutZaehler: 232 ok @24MHz (0=256)
WT_B1:  ORL     LCD,#0F0H       ;       use Bits 4..7 as inputs
        SETB    LCD_RW          ;       read mode
        CLR     LCD_RS          ;       command
        SETB    LCD_E           ;       strobe on
        MOV     A,LCD           ;       first read
        CLR     LCD_E           ;       strobe off
        SETB    LCD_E           ;       second read
        CLR     LCD_E           ;       dont transfer - Bit 7 is busy bit
        JNB     ACC.7,WT_B2     ; ... warten auf LCD fertig
        DJNZ    R3,WT_B1        ; Timeout
WT_B2:  RET
W_LCD:  CLR     LCD_RW          ; linkes Halbbyte aus Akku -> LCD
        ANL     A,#0F0H
        ANL     LCD,#0FH
        ORL     LCD,A           ;       set data bits
        SETB    LCD_E           ;       strobe
        CLR     LCD_E
        RET
ENDIF	;----------------------------------------------------------------------

LIBEND


;******************************************************************************
LIBRARY EOF

EOF?C	SEGMENT CODE

RSEG	EOF?C

PUBLIC ?EOF

?EOF:	MOV	A,R3
	JZ	EOF0
	RET
	
EOF0:	MOV	C,1
	RET

LIBEND
	
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;  These two last library modules MUST be the last input for the LINK51.
;
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

LIBRARY ISTACK

PUBLIC	?INITISTACK

EXTRN DATA ( ?STACKPTR )
EXTRN	CODE ( ?INITVAR )

?ISTACK?I	SEGMENT	IDATA
?ISTACK?C	SEGMENT CODE

RSEG	?ISTACK?I

?ISTACKSTART:
	DS	1	; stack in upper part of internal memory
	
RSEG	?ISTACK?C

?INITISTACK:
	MOV	?STACKPTR,#?ISTACKSTART
	POP	0
	POP	1
	MOV	SP,?STACKPTR
	PUSH	1
	PUSH	0
	JMP	?INITVAR
	

LIBEND


;******************************************************************************
LIBRARY	STACK
PUBLIC	?STACKPTR
PUBLIC	?INITSTACK
EXTRN	CODE(?INITVAR)
EXTRN	DATA(?STACK)
?STACK?D	SEGMENT	DATA
?STACK?C	SEGMENT	CODE
RSEG	?STACK?D

?STACKPTR:
	DS	1	; initial value for transfer

RSEG	?STACK?C

?INITSTACK:
	MOV	?STACKPTR,#?STACK
	POP	0
	POP	1
	MOV	SP,?STACKPTR
	PUSH	1
	PUSH	0
	JMP	?INITVAR
	
	
LIBEND


;******************************************************************************
LIBRARY VARINIT

PUBLIC		?INITVAR
EXTRN	DATA	( ?STACKPTR )
EXTRN	CODE	( ?INITSTART,?INITEND )

VARINIT?C	SEGMENT	CODE
RSEG	VARINIT?C

?INITVAR:
	MOV	R0,#21H	; Clear DATA static variable memory
	MOV	A,#?STACKPTR
	ADD	A,#-21H
	JZ	INITREP-3
	MOV	R1,A
	MOV	@R0,#0
	INC	R0
	DJNZ	R1,$-3
	MOV	DPTR,#?INITSTART
INITREP:
	CLR	A
	MOVC	A,@A+DPTR
	MOV	R3,A
	CLR	A
	INC	DPTR
	MOVC	A,@A+DPTR
	MOV	R2,A
	ORL	A,R3
	JZ	INITE

	INC	R3
	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR
	MOV	R5,A
	CLR	A
	INC	DPTR
	MOVC	A,@A+DPTR
	MOV	R4,A

	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR
	MOV	R7,A
	CLR	A
	INC	DPTR
	MOVC	A,@A+DPTR
	MOV	R6,A
	
	INC	DPTR
	CLR	A
	MOVC	A,@A+DPTR
; test for memory type to initialize
	JZ	INID
; XDATA to initialize
	MOV	R0,DPL
	MOV	R1,DPH
INITR:	MOV	DPL,R4
	MOV	DPH,R5
	CLR	A
	MOVC	A,@A+DPTR
	INC	DPTR
	MOV	R4,DPL
	MOV	R5,DPH
	MOV	DPL,R6
	MOV	DPH,R7
	MOVX	@DPTR,A
	INC	DPTR
	MOV	R6,DPL
	MOV	R7,DPH
	DJNZ	R2,INITR
	DJNZ	R3,INITR
	
	MOV	DPL,R0
	MOV	DPH,R1
	INC	DPTR
	SJMP	INITREP
	
INID:	MOV	B,DPL
	MOV	R1,DPH
	MOV	A,R7
	MOV	R0,A
	MOV	DPL,R4
	MOV	DPH,R5
	
INIDR:  MOV	A,#0
	MOVC	A,@A+DPTR
	MOV	@R0,A
	INC	R0
	INC	DPTR
	DJNZ	R2,INIDR
	DJNZ	R3,INIDR
	
	MOV	DPL,B
	MOV	DPH,R1
	INC	DPTR
	SJMP	INITREP
INITE:	RET

LIBEND

;******************************************************************************
LIBRARY DUMMYINIT

; This dummy library function is added 960413 to get Pascal and C compatible with
; each other. It will only be loaded if the compiler do not supply the entries
; defined in here.

PUBLIC  ?INITSTART

?INITSTART:

LIBEND

LIBRARY VARINIT1


PUBLIC		?INITEND

INITCODE	SEGMENT	CODE

RSEG	INITCODE

?INITEND:
	DW	0	; end of initialization chain

LIBEND


END


