;Assemblerfunktion: Max144 12Bit-Wandlung                     01-01-07 DA
;Parameter: KanalNummer 0 oder 1 (anderes als 1 wird als 0 angenommen)
;Rueckgabe: gewandelter Wert als Integer (bei Fehler: -1 -> FFFF)
;
;**********************************************************
; FUNKTION: int iMax144(int iKanal)
;**********************************************************

NAME    ADC_MODUL1              ;Definition des Modulnamens

?PR?iMax144?ADC_MODUL1 Segment CODE             ;Segment fr Programmcode
?DT?iMax144?ADC_MODUL1 Segment DATA OVERLAYABLE ;Byte-Parameter & -Variable      

PUBLIC  iMax144, ?iMax144?BYTE  ;Symbole fr C-Programm veroeffentlichen

RSEG    ?DT?iMax144?ADC_MODUL1  ;lokale Byte-Variable
?iMax144?BYTE:
iKan:   ds      2               ;Parameter int KanalNummer
adcd:   ds      2               ;lokale Variable ADC-Daten

sda	bit     p1.2            ;MAX144 serial data
scl  	bit     p1.3            ;MAX144 serial clock
adcs    bit     p3.5            ;MAX144 chip select	

RSEG    ?PR?iMax144?ADC_MODUL1  ;Beginn des Programmteils *****************
        
iMax144:
adc:    acall   adc_t           ;AD-Wandler Ergebnis in adcd+1(MSB)/adcd
        cjne    r2,#100,adc_1   ;? kein Fehler: Test KanalNummer
        mov     adcd,   #0ffh   ; ... sonst Fehlerkennung
        mov     adcd+1, #0ffh   ;           Fehlerkennung
        sjmp    adc_e           ;               Rueckkehr
adc_1:  mov     a,      iKan    ;wenn KanalNummer nicht 1
        cjne    a,#1,   adc_0   ; ... Kanal 0 wandeln
        mov     a,      iKan+1
        cjne    a,#0,   adc_0
        mov     a,      adcd+1  ;Kanal 1 gewandelt?        
        jnb     acc.4,  adc     ;wenn Kanal 0: nochmal wandeln (Kanal1)
        clr     acc.4           ; ... sonst Kanalbit loeschen
        mov     adcd+1, a
        sjmp    adc_e           ;        Rueckgabewerte laden
adc_0:  mov     a,      adcd+1  ;Kanal 0 gewandelt?
        jb      acc.4,  adc     ;wenn Kanal 1: nochmal wandeln (Kanal0)
adc_e:  mov     r3,adcd+1       ;Rueckgabewerte fr C-Programm (kontr.):
        mov     r2,adcd         ;       bit            Carry-Flag
                                ;       char           R2
        ret                     ;       int            R2+R3   MSB in R3
    
adc_t:  setb    adcs            ;Ausgangszustand - Timing fr 24MHz
        setb    sda             
        setb    scl             ;scl-1 -> Internal Clock Mode
        clr     adcs            ;ADC aktivieren
        clr     a               ;SRG fr Datenempfang lschen
        nop
        nop                     ;tWAKE min.2.5s
        nop
        nop
        clr     scl		;Wandlung starten
        mov     r2,     #100    ;   ... nach 120ns MAX144: sda=0
adc_t4: jb      sda,    adc_t3  ;sda=1 - EOC (end of conversion) max.7s
        djnz    r2,     adc_t4  ;Timeout: falls MAX144 nicht antwortet
        ret
adc_t3: mov     r3,     #3      ;3 Bit vergessen (sind 1)
adc_t1: setb    scl
        clr     scl
        djnz    r3,     adc_t1
        mov     r3,     #5      ;5 Bit einlesen (Kanal-Nr., D11 ... D8)
        acall   adc_t2
        mov     adcd+1, a       ;MSBs speichern
        mov     r3,     #8      ;8 Bit einlesen (D7 ... D0)
        acall   adc_t2
        mov     adcd, a         ;LSBs speichern
        setb    scl             ;Ruhezustand
        setb    adcs
        ret
adc_t2: setb    scl
        mov     c,      sda     ;Datenbit holen ...
        clr     scl
        rlc     a               ;... ins SRG
        djnz    r3,     adc_t2
        ret

        end
