/* Temperatur jede Sekunde -> serielle Schnittstelle         01-01-07 DA */

#pragma SMALL                   // kein externer Datenspeicher

#include <stdio.h>              // Standard Ein-/Ausgabe-Funktionen            

# define TRUE  1
# define FALSE 0

int iMax144(int iKanal);        // ADC wandeln: Kanal 0/1 (!=1 -> 0)
                                // Rckgabewert negativ -> Fehler
int             iSec = 0;       // Globale Variable
unsigned int    uiUhr = 0;

void inctimer (void) interrupt TIMER0
{                               // Aufruf alle 125s
  if (uiUhr++ == 8000)
  {
   iSec = 1;                    // einmal pro Minute
   uiUhr = 0;
  }
}

void main (void)
{
  int   iKanal=1,iADWert=0,iGrad=0;
  
/*int   i,j;
  for (i=0;i<1000;i++)          // garantee reprogrammablity
    for (j=0;j<100;j++){}       // (see errata, wait >500ms )*/
  
  TMOD  = 2;                    // Timer0 M1 true: 8 bit autoreload timer
  TH0   = 6;                    // interrupt every 125 microsecond @25MHz
  TR0   = TRUE;                 // Timer0 einschalten
  ET0   = TRUE;                 // enable timer0 interrupts
  EA    = TRUE;                 // enable general interrupt
  
  fopen(stdout);                // Initialisierung Standard Ein-/Ausgabe
  printf ("\nHi, hier ist dein C!\n"); // Lebenszeichen
  
  fopen(display);
  fprintf (display,"\n** AT 89S8252 **\n");
  
  while (1)                             // Endlosschleife
  {
   if (iSec)                            // einmal pro s ist bSec = 1
   {
    iADWert = iMax144(iKanal);          // gewandelten Wert abholen
    
    if (iADWert < 0)
    { 
      printf (" **** Fehler!\n");
      fprintf (display,"\t   **** Fehler!\n");
    }
    else                                // Test auf gltigen Wert
    {
      iGrad=25+(((iADWert-696)*10)/23); // Vt=690mV @25C; TK=2,3mV/C
                                        // gemessen: 696mV @25C
      printf ("%+4d Celsius\n",iGrad); // Ausgabe -V24-> PC
      fopen(display);
      fprintf (display,"\n** AT 89S8252 **\n");
      fprintf (display,"\t%  4d Celsius\n",iGrad);
    }
    P1.0 = !P1.0;                       // Blinker P1.0
    iSec = 0;
   }
  }
}
